#include "gra.ch"
#include "xbp.ch"
#include "Appevent.ch"


PROCEDURE Appsys
RETURN

PROCEDURE Main
LOCAL nEvent, mp1, mp2, oXbp
LOCAL oDlg, oDraw, oGrp, oStatic
LOCAL iMax := 400
LOCAL oPS

   oDlg          := XbpDialog():new(AppDesktop(),, {0,0}, {800,600} )
   oDlg:title    := "Test Static Controls"
   oDlg:tasklist := .T.
   oDlg:create()
   oDlg:DrawingArea:SetColorBG(GRA_CLR_WHITE)
*   oDlg:DrawingArea:clipChildren := .T.
   CenterControl(oDlg)

   oDraw := oDlg:drawingArea

   oGrp         := XbpStatic():new( oDraw,,, {iMax, iMax }  )
   oGrp:type    := XBPSTATIC_TYPE_GROUPBOX
   oGrp:caption := "Gruppe"
*   oGrp:caption := " "
*   oGrp:clipChildren := .F.
*   oGrp:drawMode := XBP_DRAW_OWNER
*   oGrp:draw := {| oPS, aInfo, oSelf| DrawGrid( oPS, aInfo, oSelf) }
   oGrp:create()
  oGrp:SetColorBG(GRA_CLR_YELLOW)
   CenterControl(oGrp,oDlg)

*IF PCOUNT() > 0
   oStatic         := XbpStatic():new(oGrp,,{3,4}, {iMax-7,iMax-13 },,.F.  )
   oStatic:caption := "Test"
*   oStatic:caption := " "
   oStatic:clipChildren := .F.
   oStatic:drawMode := XBP_DRAW_OWNER
   oStatic:draw := {| oPS, aInfo, oSelf| DrawGrid( oPS, aInfo, oSelf) }
   oStatic:create()
  oStatic:SetColorBG(GRA_CLR_CYAN)
   oStatic:Show()
   oStatic:invalidateRect()
*ENDIF

IF PCOUNT() > 0
   oPS := oStatic:LockPS()
   DrawGrid(oPS)
   oStatic:UnLockPS()
ENDIF

   nEvent := 0
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO

RETURN


PROCEDURE DrawGrid(oPS, aInfo, oSelf)
LOCAL aAttr, i, iMax := 400

   aAttr := Array( GRA_AL_COUNT )
   aAttr[GRA_AL_COLOR] := GRA_CLR_BLACK

   FOR i := 0 TO iMax STEP 10
      IF (i % 100) = 0
         aAttr[GRA_AL_COLOR] := GRA_CLR_RED
      ELSE
         aAttr[GRA_AL_COLOR] := GRA_CLR_BLACK
      ENDIF
      graSetAttrLine(oPS, aAttr )

      GraLine(oPS, {i,0}, {i,iMax} )
      GraLine(oPS, {0,i}, {iMax,i} )
   NEXT

RETURN

*
*
*